extends Window
class_name DragonAdder


@export var hat_outfits: DragonOutfit
@export var shirt_outfits: DragonOutfit
@export var shoes_outfits: DragonOutfit

var code_generator: CodeGenerator

@onready var line_edit: LineEdit = $CanvasLayer/LineEdit

signal dragon_added(dragon_name: String, hat: Texture2D, shirt: Texture2D, shoes: Texture2D)


func _ready() -> void:
	code_generator = CodeGenerator.new(hat_outfits, shirt_outfits, shoes_outfits)


func _on_button_pressed() -> void:
	var dragon: Dictionary = code_generator.descrypt(line_edit.text)
	if dragon['name'] == null:
		return
	
	var name: String = dragon['name']
	var hat: Texture2D = dragon['hat']
	var shirt: Texture2D = dragon['shirt']
	var shoes: Texture2D = dragon['shoes']
	
	dragon_added.emit(name, hat, shirt, shoes)
	
	queue_free()

func _on_close_requested() -> void:
	queue_free()
